package com.persagy.ztkedgeclouddatasecurity.config;


import lombok.Data;
import lombok.Setter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
@ConfigurationProperties(prefix = "project")
public class SystemProperties {

    @Setter
    private List<Config> configs;

    @Data
    private static class Config {
        private String name;
        private int port;
        private String ip;
        private String projectid;
    }

    private static SystemProperties systemProperties;

    @Autowired
    public void setTestProperties(SystemProperties systemProperties) {
        SystemProperties.systemProperties = systemProperties;
    }

    public static Config getByName(String name) {
        for (Config c : systemProperties.configs) {
            if (c.getName().equals(name)) {
                return c;
            }
        }
        return null;
    }
}
