package com.persagy.ztkedgeclouddatasecurity.datasafety;

import cn.shuibo.config.SecretKeyConfig;
import cn.shuibo.util.Base64Util;
import cn.shuibo.util.RSAUtil;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

@Service
public class DecryptInputMessageService implements  DecrypInputMessageInterface {

    private Logger log = LoggerFactory.getLogger(this.getClass());
    @Value("${rsa.encrypt.privateKey}")
    private  String privateKey;

    @Value("${rsa.encrypt.showLog}")
    private  boolean showLog;

    @Autowired
    private SecretKeyConfig secretKeyConfig;

    @Override
    public String DecryptMsgInputMessage(String inputMessage) {
        String charset =secretKeyConfig.getCharset();
        if (StringUtils.isEmpty(privateKey)) {
            throw new IllegalArgumentException("privateKey is null");
        }
        String content = inputMessage;
        String decryptBody="";
        try{

            if (content.startsWith("{")) {
                log.info("Unencrypted without decryption:{}", content);
                decryptBody = content;
            } else {
                StringBuilder json = new StringBuilder();
                content = content.replaceAll(" ", "+");

                if (!StringUtils.isEmpty(content)) {
                    String[] contents = content.split("\\|");
                    for (String value : contents) {
                        value = new String(RSAUtil.decrypt(Base64Util.decode(value), privateKey), charset);
                        json.append(value);
                    }
                }
                decryptBody = json.toString();
                if (showLog) {
                    log.info("Encrypted data received：{},After decryption：{}", content, decryptBody);
                }
            }}catch (Exception e){
            e.printStackTrace();
        }
        return decryptBody;
    }

}

