package com.persagy.ztkedgeclouddatasecurity.entity;

import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingQueue;

public class NettyMessageQueue {
    //队列大小
    static final int QUEUE_MAX_SIZE = 1000000;

    static BlockingQueue<String> blockingQueue = new LinkedBlockingQueue<>(QUEUE_MAX_SIZE);

    static BlockingQueue<NettyMessage> blockingQueuecloud = new LinkedBlockingQueue<>(QUEUE_MAX_SIZE);

    /**
     * 私有的默认构造子，保证外界无法直接实例化
     */
    private NettyMessageQueue() {
    }

    //单例队列
    public static NettyMessageQueue getNettyMessageQueue() {
        return SingletonHolder.queue;
    }

    //生产入队
    public void produce(String commandResult) throws InterruptedException {
        blockingQueue.put(commandResult);
    }

    //边缘到云生产入队
    public void cloudproduce(NettyMessage commandResult) throws InterruptedException {
        blockingQueuecloud.put(commandResult);
    }




    //消费出队
    public BlockingQueue<String> consume() throws InterruptedException {
        return blockingQueue;
    }

    // 获取队列大小
    public int size() {
        return blockingQueue.size();
    }

    /**
     * 类级的内部类，也就是静态的成员式内部类，该内部类的实例与外部类的实例
     * 没有绑定关系，而且只有被调用到才会装载，从而实现了延迟加载
     */
    private static class SingletonHolder {
        /**
         * 静态初始化器，由JVM来保证线程安全
         */
        private static final NettyMessageQueue queue = new NettyMessageQueue();
    }
}
