package com.persagy.ztkedgeclouddatasecurity.kafka;

import com.alibaba.fastjson.JSONObject;
import com.persagy.ztkedgeclouddatasecurity.datasafety.EncryptInputMessageService;
import lombok.extern.slf4j.Slf4j;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.kafka.support.SendResult;
import org.springframework.stereotype.Component;
import org.springframework.util.concurrent.ListenableFuture;
import org.springframework.util.concurrent.ListenableFutureCallback;

import java.util.concurrent.BlockingQueue;


@Component
@Slf4j
public class CloudKafkaProducer {
    private static Logger logger = LoggerFactory.getLogger(CloudKafkaProducer.class.getClass());

    @Autowired
    private KafkaTemplate<String, Object> kafkaTemplate;

    @Autowired
    private EncryptInputMessageService encryptInputMessageService;

    @Value("${spring.location}")
    private String location;





//    public void producerMsg(BlockingQueue<String> queue){
//
//    }
    @ConditionalOnProperty(prefix = "spring", name="location", havingValue="Cloud")
    public  void  CloudproducerMsg(JSONObject msgObj){

        String TOPIC = location+"_"+ msgObj.getString("projectid");
        //发送消息
        ListenableFuture<SendResult<String, Object>> future = kafkaTemplate.send(TOPIC, encryptInputMessageService.beforeBodyWrite(msgObj.toString()));
        future.addCallback(new ListenableFutureCallback<SendResult<String, Object>>() {
            @Override
            public void onFailure(Throwable throwable) {
                //发送失败的处理
                logger.info(TOPIC + " - 生产者 发送消息失败：" + throwable.getMessage());
            }

            @Override
            public void onSuccess(SendResult<String, Object> stringObjectSendResult) {
                //成功的处理
                logger.info(TOPIC + " - 生产者 发送消息成功：" + stringObjectSendResult.toString());
            }
        });

    }





}
