package com.persagy.ztkedgeclouddatasecurity.netty;


import com.persagy.ztkedgeclouddatasecurity.entity.ChattingUser;
import com.persagy.ztkedgeclouddatasecurity.kafka.EdgeKafkaProducer;
import io.netty.channel.ChannelInitializer;
import io.netty.channel.socket.SocketChannel;

public class MyChannelInitializer extends ChannelInitializer<SocketChannel> {

    private final EdgeKafkaProducer edgeKafkaProducer;
    private ChattingUser chattingUser;

    public MyChannelInitializer(ChattingUser chattingUser, EdgeKafkaProducer edgeKafkaProducer) {
        this.chattingUser = chattingUser;
        this.edgeKafkaProducer = edgeKafkaProducer;
    }

    @Override
    protected void initChannel(SocketChannel channel) {
//        channel.pipeline().addLast(new IdleStateHandler(60, 0, 0, TimeUnit.SECONDS));
        //对象传输处理[解码]
        channel.pipeline().addLast(new ObjDecoder());
        // 在管道中添加我们自己的接收数据实现方法
        channel.pipeline().addLast(new MsgHandler(chattingUser,edgeKafkaProducer));
        //对象传输处理[编码]
        channel.pipeline().addLast(new ObjEncoder());
    }

}
