package com.persagy.ztkedgeclouddatasecurity.netty.cloud;

import com.persagy.ztkedgeclouddatasecurity.kafka.CloudKafkaConsumer;
import com.persagy.ztkedgeclouddatasecurity.kafka.CloudKafkaProducer;
import com.persagy.ztkedgeclouddatasecurity.netty.ObjDecoder;
import com.persagy.ztkedgeclouddatasecurity.netty.ObjEncoder;
import io.netty.channel.ChannelInitializer;
import io.netty.channel.socket.SocketChannel;

public class CenterChannelInitializer   extends ChannelInitializer<SocketChannel> {
    private final  CloudKafkaConsumer cloudKafkaConsumer;
    private final NettyClient nettyClient;
    private final String projectID;
    private final CloudKafkaProducer cloudKafkaProducer;



    public CenterChannelInitializer(CloudKafkaConsumer cloudKafkaConsumer, NettyClient nettyClient,String projectID,CloudKafkaProducer cloudKafkaProducer) {
        this.cloudKafkaConsumer = cloudKafkaConsumer;
        this.nettyClient = nettyClient;
        this.projectID = projectID;
        this.cloudKafkaProducer = cloudKafkaProducer;
        //加参数

    }

    @Override
    protected void initChannel(SocketChannel channel) throws Exception {
//        channel.pipeline().addLast(new IdleStateHandler(0,60,0, TimeUnit.SECONDS));
        //对象传输处理
        channel.pipeline().addLast(new ObjDecoder());
        // 在管道中添加我们自己的接收数据实现方法
        channel.pipeline().addLast(new CenterClientHandler(cloudKafkaConsumer, nettyClient,projectID,cloudKafkaProducer));
        channel.pipeline().addLast(new ObjEncoder());
    }

}
